local f = loveframes.Create("frame")
local objSize = 100
local oC
f:SetState("gfxMenu")
f:SetName("Graphic Settings")
f:Center()
f:SetDockable(false)
f:ShowCloseButton(false)
f:SetResizable(false)
f.UpdateFlag = false

oC = (f:GetWidth() - 2*objSize)/2

--[[
Dirty Function! Use Substrings
  --Aps_infinity
]]--

f.resLbl = loveframes.Create("text", f)
  f.resLbl:SetPos(oC, 30)
  f.resLbl:SetText("Fullscreen")

f.fsLbl = loveframes.Create("text", f)
  f.fsLbl:SetPos(objSize + 15 + oC, 30)
  f.fsLbl:SetText("Resolution")

f.res = loveframes.Create("multichoice", f)
  local w, h, _ = love.window.getMode()
  f.res:SetWidth(objSize)
  f.res:SetPos(oC, 45)
  f.res:SetText(w .. "x" .. h)
  f.res.sysRes = love.window.getFullscreenModes(1)
  table.sort(f.res.sysRes, function(a,b) return a.width*a.height < b.width*b.height end)
  f.res.index = {}
  local i = 1
  for _, v in pairs(f.res.sysRes) do
    local s = v.width .. "x" .. v.height
    f.res:AddChoice(s)
    f.res.index[s] = i
    i = i + 1
  end

f.res.OnChoiceSelected = function(object, choice)
  local val = f.res.sysRes[f.res.index[choice]]
  local _, _, flags = love.window.getMode()
  ScreenAdjust(val.width, val.height, flags)
  f.res:SetText(choice)
  f.UpdateFlag = true
end

f.fullscrn = loveframes.Create("multichoice", f)
  f.fullscrn:SetWidth(objSize)
  f.fullscrn:SetPos(objSize + 15 + oC, 45)
  f.fullscrn:AddChoice("Fullscreen")
  f.fullscrn:AddChoice("Borderless")
  f.fullscrn:AddChoice("Off")
  
  function f.fullscrn.UpdateText(txt)
    f.fullscrn:SetText(f.fsText)
  end
  
  local fs, fstype = love.window.getFullscreen()
  if fs and fstype == "desktop" then
    f.fsText = "Borderless"
  elseif fs and fstype == "normal" then
    f.fsText = "Fullscreen"
  else
    f.fsText = "Windowed"
  end
  f.fullscrn.UpdateText(f.fsText)
  
  f.fullscrn.OnChoiceSelected = function(object, choice)
    local fstype
    fs = true
    if choice == "Borderless" then
      fstype = "desktop"
    elseif choice == "Fullscreen" then
      fstype = "normal"
    else
      fs = false
    end
    local _, _, flags = love.window.getMode()
    flags.fullscreentype = fstype
    flags.fullscreen = fs
    f.fullscrn.UpdateText(choice)
    local sysSet = Settings.system
  
    if fs then
      local w, h = love.window.getDesktopDimensions()
      if not sys.fsSettings.w == 0 then
        w, h = sysSet.fSettings.w, sysSet.fSettings.h
      end
    else
      local w, h = love.window.getDesktopDimensions()
      local scale = .65
      w, h = w*scale, h*scale
      if not sysSet.windowSettings.w == 0 then
        w, h = sysSet.windowSettings.w, sysSet.windowSettings.h
      end
    end
    ScreenAdjust(w, h, flags)
  end