Entity = class('Entity')

function Entity:initialize(t)
	--t is the info from data/units/GMTest.lua
  self.threat = t.threat
  self.status = t.status
  self.equipped = t.equipped
  self.location = t.location
  self.spells = t.spells
  self.inventory = t.spells
  self.move = t.move
  self.imgName = t.imgName
  self.animNames = t.animNames
  self.animLengths = t.animLengths
  self.info = t.info
  self.dimensions = t.dimensions
	self.moving = false
	self.udt = 0
	self.dSprite = 0
  self:loadSprite(self.imgName, self.animNames, self.animLengths)
	self.sprite:setFrame(self.animNames[1], 1)
end

function Entity:getUnitLevel()
  return self.info.level
end

function Entity:getUnitType()
  return self.info.type
end

function Entity:getUnitName()
  return self.info.name
end

function Entity:getUnitSubName()
  return self.info.subName
end

function Entity:getUnitFaction()
  return self.info.faction
end

function Entity:setUnitLevel(lvl)
  self.info.level = lvl
end

function Entity:loadSprite(img, nTable, sTable)
  --Format for Entity sprites!
  --Forward-Walk Backward-Walk
  --Left-Walk Right-Walk
  --Forward-Attack Backward-Attack
  --Left-Attack Right-Attack
  --Forward-Cast Backward-Cast
  --Left-Cast Right-Cast
  --Forward Death
  --Backward Death
  --Left Death
  --Right Death
  self.sprite = Sprite:new(self.info.name)
  local quad = 1
  for i = 1, #nTable, 1 do
    self.sprite:addAnimation(nTable[i], img, quad, sTable[i])
    quad = quad + sTable[i] + 1
  end
end

function Entity:setGUID(id)
  self.info.GUID = id
end

function Entity:objectType()
  return "Entity"
end

function Entity:getPosition()
	return self.location.x, self.location.y
end

function Entity:getGUID()
	return self.info.GUID
end

function Entity:getSpeed()
	return self.status.speedMod * self.status.speedpercent
end

function Entity:setSpeed(x)
	self.status.speedMod = x
end

function Entity:setSpeedpercent(x)
	self.status.speedpercent = x
end

function Entity:moveTo(x, y)
	self.location.x = x
	self.location.y = y
end

function Entity:attack(target)
	local r = self.attackRange
	local tx, ty = target:getPosition()
	local ix, iy = self.getPosition()
	local d = math.sqrt( (tx - ix) ^ 2 + (tx - ix) ^ 2 ) 
	if d <= r then
		dmg = World:attackCalc((self.attribute.damage + self.status.modDamage) * self.status.dmgScale, target.attribute.armor, self.attribute.armorPen, self.level, target.level)
		target:modifyHealth(dmg)
		if not World:isInCombat(self.GUID) and dmg > 0 then
			World:enterCombat(self.GUID)
		end
		local tarId = target.GUID
		if not World:isInCombat(tarId) and dmg > 0 then
			World:enterCombat(tarId)
		end
	else
		local n = d - r
		local mx, my = (tx - ix)(n/d) + ix, (ty - iy)(n/d) + iy
		World.attackMove(self.GUID, mx, my)
		World.registerAttack(self.GUID, tarId)
	end
end