tableFile = class('tabelFile')


function tableFile:append(tabs, string)
  for i = 0, tabs, 1 do
    self.write = self.write .. self.tab
  end
  self.write = self.write .. string
end

function tableFile:initialize()
  --Generic structure pieces
  self.endLine = "\n"
  self.startFile = "return"
  self.endSection = "}" .. self.endLine
  self.equal = " ="
  self.separate = "," .. self.endLine
  self.newTable = "{" .. self.endLine
  self.tableSeparate = "}," .. self.endLine
  self.write = ""
  self.tab = "  "
  self.currentTab = 1
  self:append(self.currentTab, self.startFile)
  self.inTable = false
  self.tCount = 0
end

function tableFile:newIndent()
  self.currentTab = self.currentTab + 1
end

function tableFile:endIndent()
  self.currentTab = self.currentTab - 1
end

function tableFile:serialize(o, name)
  --Value is not a table or writable so we add its name to the file
  if type(o) == "number" or type(o) == "string" or type(o) == "boolean" then
    if self.inTable and (type(name) == "string" or type(o) == "boolean") then
      self:append(self.currentTab, "[\"" .. name .. "\"]" .. self.equal)
    elseif type(name) == "number" then
      self:append(self.currentTab, "[" .. name .. "]" .. self.equal)
    else
      self:append(self.currentTab, name.. self.equal)
    end
  end
  --Type is a number so we just output raw
  if type(o) == "number" then
    self:append(0, o .. self.separate)
    return
  --Type is a string so we format it
  elseif type(o) == "boolean" then
    if o then
      self:append(0, "true" .. self.separate)
    else
      self:append(0, "false" .. self.separate)
    end
    return
  elseif type(o) == "string" then
    self:append(0, string.format("%q", o) .. self.separate)
    return
  --Type is a table so we recursively serialize its components
elseif type(o) == "table" then
    self.tCount = self.tCount + 1
    if not self.inTable and self.
    tCount >= 2 then
      self.inTable = true
    end
    if name ~= nil then
      self:append(self.currentTab, name .. self.equal .. self.newTable)
    else
      self:append(self.currentTab, self.newTable)
    end
    self:newIndent()
    for k, v in pairs(o) do
      self:serialize(v, k)
    end
    self:endIndent()
    if self.tCount > 1 then
      self:append(self.currentTab, self.tableSeparate)
    else
      self:append(self.currentTab, self.endSection)
    end
    self.tCount = self.tCount - 1
    if self.tCount == 1 then
      self.inTable = false
    end
  end
end
